Installer – The option to 'install third-party software' when installing Ubuntu should be selected by default (aka "make Youtube work")

Reported by John Lea on 2011-02-23
66
This bug affects 8 people
Affects Status Importance Assigned to Milestone
Ayatana Design
Undecided
Unassigned
ubuntu-community
Undecided
Ubuntu Technical Board
ubiquity (Ubuntu)
Wishlist
Evan Dandrea

Bug Description

Note: this request was discussed at the Ubuntu Technical Board meeting on 2011-03-24 with an unanimous decision not to make the requested alterations to Ubiquity, the Ubuntu installer. Full details can be read on command #19 onwards and in the discussion preceding the decision, which is available at:

  http://irclogs.ubuntu.com/2011/03/24/%23ubuntu-meeting.html#t18:11

  AGREED received: Ubuntu will not enable ubuntu-restricted-* installation by default, and will retain its stance
  Final result is 0 for, 5 against. 0 abstained. Total: -5

Original report request:

Installer – The option to 'install third-party software' when installing Ubuntu should be selected by default.

There are two issues regarding this change:

1) Legal - We are currently checking the legal fine print regarding changing this option from 'not selected by default' to 'selected by default'. Legal have given us the provisional OK for this change, they are doing a final check of the EULA details atm. This issue is in legal's hands, and a final answer should arrive shortly.

2) Usability - We want free software to take over the world! And we want it to grow beyond the bounds of enthusiasts and to get casual non-techy users into the world of open source software. To do this we have to match the experience they receive from proprietary software. For example people expect YouTube to just work. If YouTube doesn't work they will say, "I tried this new computer, it looked quite nice but when I went to YouTube it didn't work so I want back to using my Mac/PC". There is a low tolerance for failure in common and basic usecases. In the world we want to get to, all the functionality users expect will be deliverable with open source software. But to get there we need to massively increase our user base and attract more developers and companies to the open source ecosystem. And we won't be able to do that if we can't meet basic casual user expectations along the way. To beat the proprietary competition our no. 1 priority has to be delivering the best possible experience to our users. Unfortunately to do this today we need to we need to let users use some elements of proprietary software. However unless we meet user expectations we will never get the user base required to support the development of open source alternatives. And when the open source alternatives match the quality of their proprietary equivalents it will no longer be necessary to have this option.

This change only proposes changing the selection of a pre-existing option in the installer to selected by default. No other changes are proposed with regards to the 'install 3rd party software' functionality that currently ships in Ubuntu.

Tags: udt Edit Tag help
John Lea (johnlea) on 2011-02-23
Changed in ayatana-design:
status: New → Fix Committed
importance: Undecided → High
assignee: nobody → John Lea (johnlea)
tags: added: udt
John Lea (johnlea) on 2011-03-01
Changed in ubiquity (Ubuntu):
assignee: nobody → Evan Dandrea (ev)
importance: Undecided → Critical
John Lea (johnlea) wrote :

Hi have spoke to Amanda and she says that this should be ok so we can go ahead with this change.

Evan Dandrea (ev) wrote :

Kate has expressed concern with this change and I've asked her to comment here on specifics.

Kate Stewart (kate.stewart) wrote :

Some third party software has licenses that are incompatible with GPL.
What are the licenses of the software that is being selected for auto-install?

We need to check that the terms of the licenses can be adhered to if the 3rd party software is installed by default.

Changed in ubiquity (Ubuntu):
importance: Critical → Medium
Kate Stewart (kate.stewart) wrote :

Also, changed priority of this bug, it does not meet the definition of critical, it is a potential optimiziation not broken function.

Mario Limonciello (superm1) wrote :

Also a point to raise, this will cause a default installation to differ whether a network is available during install or not because ubuntu-restricted-addons isn't on any installation media. Is that a concern?

Jono Bacon (jonobacon) wrote :

John, can you provide more information about how this change will improve the user experience and bring value to Ubuntu? Right now I don't feel I have enough of a handle on what this feature will bring to our users.

Although this change is only a default checkbox being selected (and assuming ticking it will automatically install proprietary drivers) this change has significant legal and policy implications for the Ubuntu project. They are:

 * Legal - are we legally able to make this change? You mentioned that Canonical's Legal Counsel has approved this, can you provide more details?
 * Policy - Ubuntu has always maintained that a default installation of Ubuntu will ship Free Software - it is my understanding that this change would change that default to ship Non-Free software. In my eyes that is a policy change for Ubuntu, and therefore there should be a discussion with the Technical Board and/or the community on ubuntu-devel. I would be uncomfortable with making this change without a suitable discussion with our community, and at least with our technical policy governing body (the Technical Board).

Can you provide more details on the goal of the change, it's intended outcome, if there are opportunities to achieve the same outcome in other ways, and if not, how you would plan to coordinate these legal and policy discussions.

Thanks.

Paul Sladen (sladen) wrote :

Ubuntu ships in many countries of the world, and while Free Software is intended to be unrestricted and open for anyone where-ever they are in the world, we have traditionally relied upon users taking responsibility for knowing about the situation in their locales when it comes to non-free software or those known to be encumbered by patent implications or other harsh restrictions.

A very small amount of non-free software is also shipped /on/ the CD, but this has traditionally been restricted to components /necessary/ to make particular hardware systems suitably functional with a Free operating system (in a nutshell: video card and wifi drivers/firmware) and is packaged separately in a way in which it can be disabled and ignored (or even removed).

The proposed change in defaults perhaps appears to be somewhat undefined/unclear in terms of (a) ground support of day-to-day Ubuntu users and developers, (b) legal implications [your consultation with Amanda is noted], (c) long-standing policies on what we promote, (d) support implications. This bug report would benefit greatly if those rationales were clearly documented here on it first.

My hunch is that this probably wants to go via the Community Council to ensure people /want it/, and via the Technical Board to ensure it's /sane/. If either of those give push-back and it's still wanted by certain parties it might be sensible to take to UDS in a couple of months.

Whilst it might seem like "only a tickbox default", it is a change in policy from toleration of non-free material in the default install (where absolutely necessary as a functional stop-gap) to a policy of implicit promotion of non-free software. Now not all third-party software is without source or proprietary, so perhaps we could also offer to differentiate along those lines if it's useful.

description: updated
Changed in ubiquity (Ubuntu):
importance: Medium → Wishlist
John Lea (johnlea) wrote :

Updated description

description: updated
Paul Sladen (sladen) on 2011-03-11
summary: Installer – The option to 'install third-party software' when installing
- Ubuntu should be selected by default
+ Ubuntu should be selected by default (aka "make Youtube work")
description: updated
John Lea (johnlea) on 2011-03-11
description: updated
John Lea (johnlea) on 2011-03-11
description: updated
Jono Bacon (jonobacon) wrote :

Hi John,

Appreciate the response and updated bug description.

In terms of the legal side, can you provide more details around the EULA discussion? I have never checked the third-party drivers box so I don't know if it shows a EULA, but if not, would there be an expectation that there would be a EULA?

I appreciate the usability clarifications, and I feel the goal of reaching end users is well understood and agreed-upon - we do need to offer at least a comparable experience to our competitors, and we should strive to improve on it. My lack of clarity was whether you feel we need to enable proprietary drivers by default to achieve this. It sounds like what you are advocating is "if a better experience can be gained from the use of a proprietary driver, we should make it simple for the user to enable such a driver".

I agree with making it simple for the user to have the best possible experience, and if they are comfortable with using proprietary drivers, it should be simple to enable them in Ubuntu. My goal in this bug is to communicate that this is not as simple as changing a default as it involves policy implications for the project. I would argue that if the "third party drivers" check-box is ticked by default, that we are enabling proprietary drivers by default, even if we give the user an opportunity to untick it (so many users just click Next until they see a progress bar). Thus, the right path for this decision is to liaise with the Technical Board, factoring in input from the Design Team, to ensure we get a great experience but maintaining the values of the project.

My recommendations for next steps:

 * We should invite the Technical Board to weigh in on this bug to decide if they feel this is indeed a technical policy change, and therefore warrants a discussion.
 * If so, the Technical Board should have a discussion to identify next steps.

My personal view:

I totally agree with the goal - we should make the best user experience just a click away. If to achieve this the user is comfortable with using proprietary drivers, they should not need to do anything special to get that better experience, but I think we could improve the messaging and communicate the implications of proprietary software (much as we do with the Restricted Drivers tool). Irrespective, if this is considered a policy change, I am conscious that we follow our published governance guidelines and involve the Technical Board.

Changed in ubiquity (Ubuntu):
status: New → Incomplete
Jono Bacon (jonobacon) wrote :

Has there been any further progress on this, John?

Martin Owens (doctormo) wrote :

Please consider that enabling by default might mean that Ubuntu provides a toxic workaround which will decrease further the amount of time and/or money put towards free implementations of flash. Which are still required for people running PPC (Mac) or Arm ports of Ubuntu.

Unless Canonical is investing in free software flash in some meaningful way to try and dig us out of the mess. Or if there is some way to encourage users to continue to pay attention to a free software replacement, then I can't see how this change is consistent with the stated goals of the Ubuntu project.

Ralph Green (severian) wrote :

This is a really bad idea. Installing the codecs easily would be fine with me. Installing Adobe Flash is an awful idea. First, the license for Adobe Flash is not even close to reasonable. You give up the right to make proper backups of your system, for example. Second, Adobe Flash exposes your system to many vulnerabilities and more are discovered frequently. I don't even run Adobe Flash, and don't miss it. If the goal is to get Youtube working out of the box, there are better alternatives. Firfox 4, which is in Natty supports WebM and Youtube is moving to that, anyway. For the old flash videos, a combination of Greasemonkey, gnash and a greasemonkey script do a pretty good job of Flash and could be polished up a bit.

Paul Sladen (sladen) wrote :

Part of this idea was proposed on the following Brainstorm entry, so that could be followed up in parallel:

  "Make YouTube work right out of the box"
  http://brainstorm.ubuntu.com/idea/7526/

Paul Sladen (sladen) wrote :

The Ubuntu-UK podcast contains an interesting 15-minute discussion on the subject.

  http://podcast.ubuntu-uk.org/2011/03/16/s04e02-stranger-in-a-strange-land/
  http://podcast.ubuntu-uk.org/download/uupc_s04e02_high.ogg (30:05 to 45:45)

From a quick listen, some very interesting points are made; comparisions with Linux Mint who ship such material by default; the potential implication for Loco groups or end-users in certain countries receiving pre-pressed CDs. A second-hand report via IRC to the show recording observes (paraphrased) that a base install of Microsoft Windows does come with MP3/Flash by default, although virtually all /OEMs/ distributing a pre-install do include those.

Finally, an attempt is made to understand/second-guess at what is being proposed in terms of the 'ubuntu-restricted-addons' and 'ubuntu-restricted-extras' meta-packages (reviewing the Ubiquity source code): highlighting that this bug report does not currently state what is /actually/ being proposed at a detailed level.

Matthew Paul Thomas (mpt) wrote :

Apple recently stopped installing Flash with Mac OS X. <http://daringfireball.net/2010/10/apple_no_longer_bundling_flash_with_mac_os_x>

Benjamin Drung (bdrung) wrote :

Enabling 'install third-party software' by default installs two different types of packages by default: free, patent-problematic packages (like gstreamer0.10-plugins-ugly and gstreamer0.10-plugins-bad) and non-free packages (like flashplugin-installer). Maybe we should split those two types and decide separately. Maybe we should have to checkboxes.

My opinion: We should enable free, patent-problematic packages, but disable non-free packages by default. This gives us still a completely free system by default. Allowing non-free by default opens the door for even more non-free stuff. Where would be the line to draw? Flash is important for most users, but unrar is important too. So we should install unrar by defaut too?

Matt Zimmerman (mdz) on 2011-03-19
Changed in ubuntu-community:
assignee: nobody → Ubuntu Technical Board (techboard)

Paul referred to the Ubuntu UK Podcast discussion, in which I mentioned I didn't think this was a good idea. I'd like to expand a bit more on why, speaking as an end-user who uses Ubuntu because it's free software.

Benjamin pointed out, as we did on the show, that some of the packages in question are free but may have patent issues in some countries. I agree that it's OK to have these enabled by default, as long at we're not putting end-users in a legally-dubious situation by doing so. As I live in the UK, this doesn't bother me, but in a country such as the USA where software patents are more of a big deal, this worries me a bit. However, this is clearly an issue for the legal team.

On Ubuntu.com, there is a paragraph summarising what Ubuntu is. The paragraph ends, "Ubuntu is, and always will be, absolutely free." This change will undermine this clear statement of principle. We all know that the word "free" is loaded in this context, so the choice to use it there was clearly considered. It doesn't matter whether removal of non-free components is unticking a box, or an apt-get remove command - the choice to install them by default means that Ubuntu is no longer "absolutely free", which could affect the distro's credibility within the free software community. These are the people tell their friends and family about Linux, and install Linux on their machines. Losing their support isn't ideal.

The description of this bug report makes it clear that a primary reason for the change is "Usability".
> For example people expect YouTube to just work. If YouTube doesn't work they will say,
> "I tried this new computer, it looked quite nice but when I went to YouTube it didn't work
> so I want back to using my Mac/PC".
This may well be true. However, if there's going to be a major policy change in the name of usability, I'd like to see some evidence that this is the case. As a developer, I know how easy it is to say "users will probably think this, so I'll do this" without ever researching what users actually think and do. I suspect that the majority of people who install Ubuntu will understand what the checkbox means, and will tick it if necessary. The reason I say that is that I think users who don't understand or notice the checkbox won't be installing Ubuntu themselves anyway - someone who does (techie friend/professional or OEM) will be doing it for them, and can check it if it's required.
Again I may well be wrong, but without properly researching it we'll never know.

My final concern is that a change like this opens the flood gates. If we've agreed that it's acceptable to include non-free software by default, where do we draw the line? Drivers? Codecs? Browser Plugins? Applications? What if a partner company wants to pay Canonical to include its proprietary software in Ubuntu by default? Any decision in this area will need a clear process for justification of packages installed through this option, otherwise we risk making a default Ubuntu install look like an OEM Windows install.

Matt Zimmerman (mdz) wrote :

This is on the agenda for today's tech board meeting, at 1800 UTC on #ubuntu-meeting (10 minutes from now)

Martin Pitt (pitti) wrote :

This was just discussed by the Ubuntu Technical Board, and unanimously (0 for, 5 against) declined. (Closing as "opinion", as I cannot set "wontfix" for the ubuntu-community state).

Ticking that box by default is by and large equivalent to always installing the software by default, as it would now require an informed decision to get only free software installed. We have always made some clearly stated concessions for hardware drivers (graphics, wlan) which http://www.ubuntu.com/project/about-ubuntu/licensing points out. But we unanimously feel that Flash does not at all fall into this category:

  * It is not required for most of the work you do with your computer, unlike a graphics driver.
  * There are free alternatives available.
  * We already make it easy to install non-free codecs and Flash plugin via totem's/Firefox' codec/plugin installer, which gives you free alternatives and also has both a more proper context as well as more space to explain the situation and alternatives than the single tick box in the installer (which is also already overloaded with different purposes) could ever convey.

This is just a line which we all strongly feel we should not cross.

Changed in ubuntu-community:
status: New → Opinion
Martin Pitt (pitti) wrote :

Another reason for the "flash" part in particular this is that there is an emerging movement away from Flash towards HTML5 and free video codecs. We felt that we should support this movement.

Changed in ubiquity (Ubuntu):
status: Incomplete → Won't Fix
Jono Bacon (jonobacon) wrote :

Thanks to the Technical Board for the discussion (http://irclogs.ubuntu.com/2011/03/24/%23ubuntu-meeting.html#t18:02) - I have set the bug to WONTFIX.

Changed in ubuntu-community:
status: Opinion → Won't Fix
Paul Sladen (sladen) on 2011-03-24
description: updated
description: updated
Paul Sladen (sladen) on 2011-03-24
description: updated
manny (estelar57) wrote :

i think there's no need for this, as long as the browser (or system) looks for the needed plugin (usually flash) and installs it when granma wants to watch her grand kids's video on youtube or one of those social networks.

So we have to make sure this is as easy as possible

Joaquin (jknvv13) wrote :

I think a YouTube player integrated on the ubuntu system with WebM support, will be good :)

Martin Pitt (pitti) wrote :

madarnie, it is already optional -- you can enable the third-party software check box in the installer.

Martin, as I understand it the tickbox is indeed optional however at the
same time, such an important feature to the desktop experience and
importance to free software as well isn't a centre of attention. The current
layout makes it appear to be some daft, worthless EULA. In the blog linked,
the installer should have its own page with just the tickbox as an option
and perhaps having a longer description by what advantages and disadvantages
there are to ticking it.

Chris
--
Ysgrifennwch ataf yn Gymraeg neu Saesneg
Anfonwyd gan fy nyfais Android

On 29 Mar 2011 09:21, "Martin Pitt" <email address hidden> wrote:

madarnie, it is already optional -- you can enable the third-party
software check box in the installer.

--
You received this bug notification because you are subscribed to ubuntu-
community.
https://bug...

Paul Sladen (sladen) wrote :

For those interested, Jono wrote a piece:

  http://www.jonobacon.org/2011/03/28/balancing-freedom-and-functionality-a-design-challenge/

The post itself includes a highlighted screenshot of the installer screen in question:

  http://farm6.static.flickr.com/5187/5568269623_e74672f3f5_z.jpg

The most intriguing suggestion mentioned on that blog is a (very beautiful) mockup, showing a slider from "free" to "non-free":

  All free software → proprietary drivers ↔ MP3 ↔ DVD ↔ Flash ← All non-free software
  http://img638.imageshack.us/img638/3886/captureqc.png

This would make the choice less binary; and allow the installer to call-out at edge level what the impact on the user-experience would be.

Daniel Holbach (dholbach) wrote :

I don't think the slider is a good idea.
 - It's conflating two different things: 1) proprietary bits (Flash, proprietary video drivers) and 2) free-but-problematic-because-of-patents (MP3, DVD).
 - It's simply not a scale: trying to weigh the usefulness is heavily dependent on who is using Ubuntu.
 - I appreciate that we're trying to think of intuitive ways to give the user choice, but why does choice A include choice B and C? Ie: if I want to play DVDs, why do I have to use proprietary video drivers?

Also remember to inform users of Adobe Flash Player EULA legal problems . The Adobe Flash Player End User License Agreement prohibits reverse engineering and more. Therefore developers cannot develop a competing Flash player if they've accepted the Adobe Flash Player EULA.

See also
https://answers.launchpad.net/ubuntu/+source/flashplugin-nonfree/+question/135400

The YouTube HTML5 Video Player works without the Adobe Flash Player plug-in.

John Lea (johnlea) on 2011-10-18
Changed in ayatana-design:
status: Fix Committed → Triaged
status: Triaged → Confirmed
John Lea (johnlea) on 2012-09-19
Changed in ayatana-design:
importance: High → Undecided
assignee: John Lea (johnlea) → nobody
Changed in ayatana-design:
status: Confirmed → Invalid
John Lea (johnlea) wrote :

@xnox; please don't change the status of bugs in ayatana-design, thx!

Changed in ayatana-design:
status: Invalid → Triaged
To post a comment you must log in.
This report contains Public information  Edit
Everyone can see this information.

Other bug subscribers